// onemax.cpp
//-----------------------------------------------------------------------------
// This sample is provided to show you how to program using GAPPA DEGA Library
// If you want to get more information about GAPPA DEGA Library, see documents
// in this archive.
// Programmed by T.Kawasaki
//-----------------------------------------------------------------------------
// DESCRIPTION:
//   ONEMAX is a simple GA test, making each bit 1

#include <iostream>
#include <gappa.h>

using namespace std;

/*
   NOTICE:
   same function has been already implemented and contained in GAPPA library
   package.

double onemax(const BitAccessor& bits)
{
	int i, score;
	for(i = score = 0; i < bits.length(); i++)
		if(bits[i]) score++;
	return (double)score;
}
*/

main(int argc, char *argv[])
{
	int tt;
	BaseGAEnvironment ga(onemax);
	if(!ga.loadSettings(argc, argv, "onemax.ini"))
	{
		cout << gappa_help;
		return 0;
	}

	for(tt = 0;; tt++)
	{
		ga.nextGeneration();

		cout << ga(0) << endl;
		if(ga(0).fitness() == 64) break;
	}
	return 0;
}
