//--------------------------------------------------------------------------
// benchtime.h
// GAPPA Parallel Distributed Environment Genetic Algorithm Library
// High Resolution Performance Timer for Benchmark Programs
//--------------------------------------------------------------------------
// Copyright (C) 2000 Takashi Kawasaki, Tomoyuki Hiroyasu and Mitsunori Miki,
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// 1. Redistributions of source code must retain the above copyright  notice
//    and this list of conditions.
// 2. Redistributions in binary form must reproduce the above  copyright notice
//    and this list of conditions in the documentation and/or other materials
//    provided with the distribution.
// 3. All advertising materials mentioning features or use of this software
//    must display the following acknowledgement:
//
//    This product includes software developed by Takashi Kawasaki,
//    Tomoyuki Hiroyasu and Mitsunori Miki except the functions of sgenrand()
//    and genrand().
//
// 4. The names of Takashi Kawasaki, Tomoyuki Hiroyasu and Mitsunori Miki
//    should not be used to endorse or promote products derived from this
//    software without specific prior written permission.

#ifndef _HIGHRES_TIMER_4_BENCH_H_
#define _HIGHRES_TIMER_4_BENCH_H_

#include <iostream>
#include "sysdep.h"

#if defined(WIN32_PLATFORM)
#include <windows.h>
#else
#include <sys/time.h>
#include <unistd.h>
#endif

class HighResTimer
{
public:
	HighResTimer();
	void startCounter();
	int getCounter() const;

private:
#if defined(WIN32_PLATFORM)
	bool fHighRes;
	LARGE_INTEGER freq;
	LARGE_INTEGER start;
	SYSTEMTIME start_st;
#else
	struct timeval start;
#endif
};

std::ostream& operator<<(std::ostream& out, const HighResTimer& tm);

#endif // _HIGHRES_TIMER_4_BENCH_H_
