//--------------------------------------------------------------------------
// gafuncs.h
// GAPPA Parallel Distributed Environment Genetic Algorithm Library
// Welknown functions implementation
//--------------------------------------------------------------------------
// Copyright (C) 2000 Takashi Kawasaki, Tomoyuki Hiroyasu and Mitsunori Miki,
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// 1. Redistributions of source code must retain the above copyright  notice
//    and this list of conditions.
// 2. Redistributions in binary form must reproduce the above  copyright notice
//    and this list of conditions in the documentation and/or other materials
//    provided with the distribution.
// 3. All advertising materials mentioning features or use of this software
//    must display the following acknowledgement:
//
//    This product includes software developed by Takashi Kawasaki,
//    Tomoyuki Hiroyasu and Mitsunori Miki except the functions of sgenrand()
//    and genrand().
//
// 4. The names of Takashi Kawasaki, Tomoyuki Hiroyasu and Mitsunori Miki
//    should not be used to endorse or promote products derived from this
//    software without specific prior written permission.

#ifndef _WELKNOWN_GA_FUNCS_H_
#define _WELKNOWN_GA_FUNCS_H_

#include "dega.h"

#ifdef __cplusplus
extern "C" {
#endif

double rastrigin(const double *x, int n);  // Rastrigin [-5.12,5.12) : 0.0
double rosenbrock(const double *x, int n); // Rosenbrock [-2.048 2.048) : 0.0
double griewank(const double *x, int n);   // Griewank [-512 512) : 0.0
double schwefel(const double *x, int n);   // Schwefel [-512 512)
double ridge(const double *x, int n);      // Ridge [-64 64) : 0.0
double onemax(const BitAccessor& bits);

#ifdef __cplusplus
}
#endif

#endif // _WELKNOWN_GA_FUNCS_H_
