//--------------------------------------------------------------------------
// syncdega.h
// GAPPA Parallel Distributed Environment Genetic Algorithm Library
// Synchronized MPI Implementation for Win32/Pthreads
//--------------------------------------------------------------------------
// Copyright (C) 2000 Takashi Kawasaki, Tomoyuki Hiroyasu and Mitsunori Miki,
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// 1. Redistributions of source code must retain the above copyright  notice
//    and this list of conditions.
// 2. Redistributions in binary form must reproduce the above  copyright notice
//    and this list of conditions in the documentation and/or other materials
//    provided with the distribution.
// 3. All advertising materials mentioning features or use of this software
//    must display the following acknowledgement:
//
//    This product includes software developed by Takashi Kawasaki,
//    Tomoyuki Hiroyasu and Mitsunori Miki except the functions of sgenrand()
//    and genrand().
//
// 4. The names of Takashi Kawasaki, Tomoyuki Hiroyasu and Mitsunori Miki
//    should not be used to endorse or promote products derived from this
//    software without specific prior written permission.

#ifndef _SYNC_DEGA_MPI_H_
#define _SYNC_DEGA_MPI_H_

#include <ctime>
#include <mpi.h>
#include "dega.h"

using namespace std;

// This class is now undocumented.
// but only difference between this and GeneEnvironment is:
//   The constructor receives 2 parameters, argc and argc that is normally
//   provided as main() arguments.
//   If you want to know more details, refer to examples/mpi_rastrigin.

class syncDegaEnvironment : public GeneEnvironment
{
	int *dest;
	mutable MTRand randScheduler;
public:
	syncDegaEnvironment(int& argc, char** & argv);
	virtual ~syncDegaEnvironment();
	virtual double getFitness(const Gene& gen) const = 0;
	virtual bool migrationProcedure(const constgene_pointer apEmigrants[], int nEmigrants);
	void synchronize();
};

#endif // _SYNC_DEGA_MPI_H_
