//--------------------------------------------------------------------------
// sysdep.cpp
// GAPPA Parallel Distributed Environment Genetic Algorithm Library
// system dependency module and macros
//--------------------------------------------------------------------------
// Copyright (C) 2000 Takashi Kawasaki, Tomoyuki Hiroyasu and Mitsunori Miki,
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// 1. Redistributions of source code must retain the above copyright  notice
//    and this list of conditions.
// 2. Redistributions in binary form must reproduce the above  copyright notice
//    and this list of conditions in the documentation and/or other materials
//    provided with the distribution.
// 3. All advertising materials mentioning features or use of this software
//    must display the following acknowledgement:
//
//    This product includes software developed by Takashi Kawasaki,
//    Tomoyuki Hiroyasu and Mitsunori Miki except the functions of sgenrand()
//    and genrand().
//
// 4. The names of Takashi Kawasaki, Tomoyuki Hiroyasu and Mitsunori Miki
//    should not be used to endorse or promote products derived from this
//    software without specific prior written permission.

#include <cstdio>
#include <cstring>
#include "sysdep.h"

//using namespace std;

void nop()
{
}

InterProcessLock::InterProcessLock(int n)
{
#if defined(_WIN32) && !defined(__CYGWIN__)
	char mutex_name[MAX_PATH];
	sprintf(mutex_name, "GaPPa_Interlock_object_%u", n);
	hMutex = CreateMutex(NULL, FALSE, mutex_name);
	// if(hMutex == NULL) ... error !
#else
	sem_id = semget((key_t)GAPPA_INTERPROCLOCK_KEY, 1, IPC_CREAT);
	// if(sem_id == NULL) ... error !
#endif
}

#if defined(_WIN32) && !defined(__CYGWIN__)
#else
void InterProcessLock::lock()
{
	struct sembuf sbuf;
	memset(&sbuf, 0, sizeof(sembuf));
	sbuf.sem_num = -1;
	sbuf.sem_flg = SEM_UNDO;
	semop(GAPPA_INTERPROCLOCK_KEY, &sbuf, 1);
}

void InterProcessLock::unlock()
{
	struct sembuf sbuf;
	memset(&sbuf, 0, sizeof(sembuf));
	sbuf.sem_num = 1;
	sbuf.sem_flg = SEM_UNDO;
	semop(GAPPA_INTERPROCLOCK_KEY, &sbuf, 1);
}

InterProcessLock::~InterProcessLock()
{
	int sem_u;
	semctl(sem_id, 0, IPC_RMID, sem_u);
}
#endif

